<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2011 Helmut Hackbarth <info@t3solution.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');

/**
 * Plugin 'JSliderNews' for the 't3s_jslidernews' extension.
 *
 * @author	Helmut Hackbarth <info@t3solution.de>
 * @package	TYPO3
 * @subpackage	tx_t3sjslidernews
 */
class tx_t3sjslidernews_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_t3sjslidernews_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_t3sjslidernews_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 't3s_jslidernews';	// The extension key.
	var $pi_checkCHash = true;

	var $sliderWidth = 700;
	var $sliderHeight = 300;                                                 
	var $imageWidth = 700;
	var $imageHeight = 300;
	var $extPath = '';
  var $DAM = 0;
  var $extConf = array();
  var $variant = 0; // option in sliderstyle 2 & 3 (slide out navigation)

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	public function main( $content, $conf ) {
		$this->conf = $conf;
    # $this->pi_setPiVarDefaults();
		$this->pi_loadLL();

    $this->extPath = t3lib_extMgm::siteRelPath($this->extKey);
    $this->init();
    $this->extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['t3s_jslidernews']);
    $this->variant = $this->conf['variant'] && ($this->conf['sliderStyle'] == 2 || $this->conf['sliderStyle'] == 3) ? 1 : 0;

    switch ($this->conf['contentStyle']) {
      case 'tt_news':
        if( t3lib_extMgm::isLoaded('tt_news') == 'TRUE' ) {
          $this->DAM = t3lib_extMgm::isLoaded('dam_ttnews') ? 1 : 0;
          $sliderRecords = $this->getSliderNewsRecords();
          $content = $this->getNews($sliderRecords);
        } else {
          $content = '<p style="color:red;">ERROR - '.$this->extKey.': tt_news is not loaded!</p>';
        }
      break;
      case 'tt_content':
        $this->DAM = t3lib_extMgm::isLoaded('dam_ttcontent') ? 1 : 0;
        $sliderRecords = $this->getSliderContentRecords();
        $content = $this->getContent($sliderRecords);
      break;
      case 'pages':
        $this->DAM = t3lib_extMgm::isLoaded('dam_pages') ? 1 : 0;
        $sliderRecords = $this->getSliderPagesRecords();
        $content = $this->getMenu($sliderRecords);
      break;
    }

    $queryNoConflict = $this->extConf['jqueryNoConflict'] ? 'jQuery.noConflict()' : 'jQuery';
    $pagerender = $this->extConf['additionalHeaderData'] ? '' : $GLOBALS['TSFE']->getPageRenderer();
    $this->addJquery($pagerender,$queryNoConflict);
    if ( $this->conf['sliderStyle'] == 7 ) {
      $this->addNivoHeaderParts($pagerender,$queryNoConflict);
    } else {
      $this->addHeaderParts($pagerender,$queryNoConflict);
    }
	
		return $this->pi_wrapInBaseClass($content);
	}
	
   
	protected function init(){
    $this->pi_initPIflexForm();
		$piFlexForm = $this->cObj->data['pi_flexform'];
 		foreach ( $piFlexForm['data'] as $sheet => $data ) {
			foreach ( $data as $lang => $value ) {
				foreach ( $value as $key => $val ) {
  				$this->conf[$key] = $this->pi_getFFvalue($piFlexForm, $key, $sheet);
          if(t3lib_div::testInt($this->conf[$key])) $this->conf[$key] = t3lib_div::intval_positive($this->conf[$key]);
        }
      }
    }
  }	


	protected function getSliderNewsRecords() {
    // get tt_news setup & conf 
    $_tt_news_setup = $GLOBALS['TSFE']->tmpl->setup['plugin.']['tt_news.'];
    $_tt_news_confArr = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['tt_news']);
		// makeInstance - tt_news
    $_tt_news_obj = t3lib_div::makeInstance('tx_ttnews');
    $_tt_news_obj->cObj = &$this->cObj; 
    $newsConf = array();
    // SELECT
    $newsConf['selectFields'] = $this->pi_prependFieldsWithTable('tt_news','uid,pid,title,datetime,image,imagecaption,imagealttext,imagetitletext,short,bodytext,author,author_email,category,type,ext_url,page,sys_language_uid,archivedate');
    if ( t3lib_extMgm::isLoaded('rgnewsce') ) $newsConf['selectFields'] .= ',tt_news.tx_rgnewsce_ce';
    if ( t3lib_extMgm::isLoaded('dam_ttnews') ) $newsConf['selectFields'] .= ',tx_damnews_dam_images';
    if ( $this->extConf['ownMarker_1'] ) $newsConf['selectFields'] .= ',tt_news.'.trim( $this->extConf['ownMarker_1'] );
    if ( $this->extConf['ownMarker_2'] ) $newsConf['selectFields'] .= ',tt_news.'.trim( $this->extConf['ownMarker_2'] );
    // WHERE
		$newsConf['where'] = ' 1=1';
    $newsConf['where'] .= $_tt_news_obj->getLanguageWhere();
		$newsConf['where'] .= '  AND tt_news.pid > 0';
    // ttnewsType 
    if( $this->conf['ttnewsType'] < 3 ) $newsConf['where'] .= ' AND tt_news.type = '.$this->conf['ttnewsType'];
    // ttnewsSysFolder 
		$newsConf['pidInList'] = $this->conf['ttnewsSysFolder'] ? $this->conf['ttnewsSysFolder'] : $_tt_news_setup['pid_list'];
    // sliderCat 
    if ( $this->conf['sliderCat'] ) {
      $newsConf['leftjoin'] = 'tt_news_cat_mm ON tt_news.uid = tt_news_cat_mm.uid_local';
      $newsConf['where'] .= ' AND (tt_news_cat_mm.uid_foreign IN ('.$this->conf['sliderCat'].'))';
    }
    // ascDesc
    $newsConf['orderBy'] = 'tt_news.'.$this->conf['ascDescField'].' DESC';
    if ( $this->conf['ascDesc'] == 1 ) $newsConf['orderBy'] = 'tt_news.'.$this->conf['ascDescField'].' ASC';
    if ( $this->conf['ascDesc'] == 2 ) $newsConf['orderBy'] = 'RAND()';
    // newsArchive
		if ( !$this->conf['newsArchive'] ) {
      $time = $GLOBALS['SIM_ACCESS_TIME'];
			$newsConf['where'] .= ' AND (tt_news.archivedate = 0 OR tt_news.archivedate > '. $time .')';
			if ( $_tt_news_setup['datetimeMinutesToArchive'] || $_tt_news_setup['datetimeHoursToArchive'] || $_tt_news_setup['datetimeDaysToArchive'] ) {
				if ( $_tt_news_setup['datetimeMinutesToArchive'] ) {
					$theTime = $time - t3lib_div::intval_positive($_tt_news_setup['datetimeMinutesToArchive'] * 60);
				} elseif ( $_tt_news_setup['datetimeHoursToArchive'] ) {
					$theTime = $time - t3lib_div::intval_positive($_tt_news_setup['datetimeHoursToArchive'] * 3600);
				} else {
					$theTime = $time - t3lib_div::intval_positive($_tt_news_setup['datetimeDaysToArchive'] * 86400);
				}
				$newsConf['where'] .= ' AND tt_news.datetime > ' . $theTime;
			}
		}
    // newsLimit
    $newsConf['max'] = $this->conf['newsLimit'] ? $this->conf['newsLimit'] : 20;
    // languageField
    $newsConf['languageField'] = $GLOBALS['TSFE']->sys_language_uid ? $GLOBALS['TSFE']->sys_language_uid : 0;
    // showNewsWithoutDefaultTranslation
    if ($_tt_news_setup['showNewsWithoutDefaultTranslation']) {
    	$newsConf['where'] = '(' . $newsConf['where'] . ' OR (tt_news.sys_language_uid=' . $GLOBALS['TSFE']->sys_language_content . ' AND NOT tt_news.l18n_parent))';
    }

    // get the result
    $newsRes = $_tt_news_obj->cObj->exec_getQuery('tt_news', $newsConf);
    $newsRow = array();
    $newsRecords = array();
    $categories = array(); 
    while ( $newsRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($newsRes) ) { 
      $nUid = $newsRow['uid']; 
      $newsRecords[$nUid] = $newsRow;
			if ( $GLOBALS['TSFE']->sys_language_content ) {
				// prevent link targets from being changed in localized records
				$tmpPage = $newsRecords[$nUid]['page'];
				$newsRecords[$nUid] = $GLOBALS['TSFE']->sys_page->getRecordOverlay('tt_news', $newsRecords[$nUid], $GLOBALS['TSFE']->sys_language_content, $GLOBALS['TSFE']->sys_language_contentOL, '');
				$newsRecords[$nUid]['page'] = $tmpPage;
				// Localization mode for images
        if (!$_tt_news_confArr['l10n_mode_imageExclude'] && $newsRecords[$nUid]['_LOCALIZED_UID']) { 
          $llRec = $this->pi_getRecord('tt_news', $newsRecords[$nUid]['_LOCALIZED_UID']);
          if( $this->DAM ) {
            if ( $llRec['tx_damnews_dam_images'] ) $newsRecords[$nUid]['llDamImage'] = TRUE;
          } else {
            $newsRecords[$nUid]['image'] = $llRec['image'] ? $llRec['image'] : $newsRecords[$nUid]['image'];
          }
          unset ($llRec);
        }
			}
      // get the categories DETAILS
      $categories = $_tt_news_obj->getCategories($nUid);
      foreach ( $categories as $key=>$cat ) {
        $newsRecords[$nUid]['catDetail'][$key]['catid'] = t3lib_div::intval_positive($cat['catid']); 
        $newsRecords[$nUid]['catDetail'][$key]['title'] = trim($cat['title']); 
        $newsRecords[$nUid]['catDetail'][$key]['single_pid'] = t3lib_div::intval_positive($cat['single_pid']);
        $newsRecords[$nUid]['catDetail'][$key]['mmsorting'] = t3lib_div::intval_positive($cat['mmsorting']);
        $newsRecords[$nUid]['catTitleList'] .= trim($cat['title']).', ';           
      }
      unset($categories);
      if( $this->DAM ) {
        if ($newsRecords[$nUid]['llDamImage']) {
          $tempUid = $newsRecords[$nUid]['uid'];
          $newsRecords[$nUid]['uid'] = $newsRecords[$nUid]['_LOCALIZED_UID'];
        }        
        $newsRecords[$nUid]['image'] = '';
        $newsRecords[$nUid] = $this->getDamData($newsRecords[$nUid], 'tt_news', 'tx_damnews_dam_images');
        if ( $newsRecords[$nUid]['llDamImage'] ) $newsRecords[$nUid]['uid'] = $tempUid;
      } else {
        $newsRecords[$nUid]['image'] = t3lib_div::trimExplode(',', $newsRecords[$nUid]['image']);
        $newsRecords[$nUid]['image'] = $newsRecords[$nUid]['image'][0];
      }
      // if the EXT rgnewsce is used and there is still no image
      if ( t3lib_extMgm::isLoaded('rgnewsce') == 'TRUE' && $newsRecords[$nUid]['tx_rgnewsce_ce'] && !$newsRecords[$nUid]['image'] ) {
        $newsRecords[$nUid] = $this->getRgnewsce($newsRecords[$nUid]);
      }                                               
      // addParams for singleLink
      if ($_tt_news_setup['useHRDates'] && $_tt_news_setup['useHRDatesSingle']) {
          if ($_tt_news_setup['useHRDatesSingleWithoutDay']) {
            $newsRecords[$nUid]['addParam'] = '&tx_ttnews[year]='.date('Y', $newsRecords[$nUid]['datetime']).'&tx_ttnews[month]='.date('m', $newsRecords[$nUid]['datetime']).'&tx_ttnews[tt_news]='.$newsRecords[$nUid]['uid'];
      		} else {
            $newsRecords[$nUid]['addParam'] = '&tx_ttnews[year]='.date('Y', $newsRecords[$nUid]['datetime']).'&tx_ttnews[month]='.date('m', $newsRecords[$nUid]['datetime']).'&tx_ttnews[day]='.date('d', $newsRecords[$nUid]['datetime']).'&tx_ttnews[tt_news]='.$newsRecords[$nUid]['uid'];
          }
      } else {
        $newsRecords[$nUid]['addParam'] = '&tx_ttnews[tt_news]='.$newsRecords[$nUid]['uid'];
      }
  		// sys_language_mode defines what to do if the requested translation is not found
      $sys_language_mode = ($_tt_news_setup['sys_language_mode'] ? $_tt_news_setup['sys_language_mode'] : $GLOBALS['TSFE']->sys_language_mode);
      // get the translated record if the content language is not the default language
      if ( $GLOBALS['TSFE']->sys_language_content ) {
  			$OLmode = $sys_language_mode == 'strict' ? 'hideNonTranslated' : '';
        $ll = $newsRecords[$nUid]['sys_language_uid'] ? TRUE : FALSE;
  			$newsRecords[$nUid] = $GLOBALS['TSFE']->sys_page->getRecordOverlay('tt_news', $newsRecords[$nUid], $GLOBALS['TSFE']->sys_language_content, $OLmode);
        if ( !$newsRecords[$nUid] && !$ll ) unset($newsRecords[$nUid]);
    	}
      // if an image is required ... unset all records without an image  
      if ( $this->conf['requireImage'] == 1 && !$newsRecords[$nUid]['image'] ) unset($newsRecords[$nUid]);
    }

    return $newsRecords;
  }


  protected function getSliderContentRecords() {  
  	// get content uids from selected pages
    if ( $this->conf['contentPages'] ) {    
  		$pageUids = t3lib_div::trimExplode(',', $this->conf['contentPages']);
  		foreach ($pageUids as $pageUid) {
        $wherePages = 'tt_content.pid='.$pageUid.' AND tt_content.sys_language_uid IN (-1,0)';  
			  $wherePages .= ' AND (tt_content.CType=\'textpic\' OR tt_content.CType=\'text\')';
   			$wherePages .= $this->cObj->enableFields('tt_content');
        $resPages = $GLOBALS['TYPO3_DB']->exec_SELECTquery('tt_content.uid', 'tt_content', $wherePages);
   			while ($rowCe = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($resPages)) $pageCeUids .= ','.$rowCe['uid']; 
        $GLOBALS['TYPO3_DB']->sql_free_result($resPages); 
  		}
  	}
		if ( $pageCeUids ) {
			if ( $this->conf['contentElement'] ) {
        $this->conf['contentElement'] = t3lib_div::uniqueList($this->conf['contentElement'] . $pageCeUids);
			} else {
				$this->conf['contentElement'] = substr($pageCeUids,1);
			}
		}
    $select = $this->pi_prependFieldsWithTable('tt_content','uid,pid,header,bodytext,image,subheader,header_link,imagecaption,date,altText,titleText,sys_language_uid');
    if ( $this->extConf['ownMarker_1'] ) $select .= ',tt_content.'.trim($this->extConf['ownMarker_1']);
    if ( $this->extConf['ownMarker_2'] ) $select .= ',tt_content.'.trim($this->extConf['ownMarker_2']);
   	$where = 'tt_content.uid IN('.$this->conf['contentElement'].') AND tt_content.sys_language_uid IN (-1,0)';
   	$where .= $this->cObj->enableFields('tt_content');
  	$rows = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows($select, 'tt_content', $where, '', ' FIELD(uid, '. $this->conf['contentElement'] .')');
    $contentRecords = array();
		foreach( $rows as $key=>$row ) {
      $contentRecords[$key] = $row;
			if ( $GLOBALS['TSFE']->sys_language_content ) {
 				$contentRecords[$key] = $GLOBALS['TSFE']->sys_page->getRecordOverlay('tt_content', $contentRecords[$key], $GLOBALS['TSFE']->sys_language_content, $GLOBALS['TSFE']->sys_language_contentOL, '');
        $contentRecords[$key]['uid'] = $contentRecords[$key]['_LOCALIZED_UID'] ? $contentRecords[$key]['_LOCALIZED_UID'] : $contentRecords[$key]['pid'];
			}
      if( $this->DAM ) {
        $contentRecords[$key]['image'] = '';
        $contentRecords[$key] = $this->getDamData($contentRecords[$key], 'tt_content', 'tx_damttcontent_files');
      }
      // get the translated record if the content language is not the default language
      if ( $GLOBALS['TSFE']->sys_language_content ) {
        $OLmode = $GLOBALS['TSFE']->sys_language_mode == 'strict' ? 'hideNonTranslated' : '';
        $ll = $contentRecords[$key]['sys_language_uid'] ? TRUE : FALSE;
    		$contentRecords[$key] = $GLOBALS['TSFE']->sys_page->getRecordOverlay('tt_content', $contentRecords[$key], $GLOBALS['TSFE']->sys_language_content, $OLmode);
        if ( !$contentRecords[$key] && !$ll ) unset($contentRecords[$key]);
      }
		}
                                                                   
    return $contentRecords; 
  }  


	protected function getSliderPagesRecords() {
    $select = $this->pi_prependFieldsWithTable('pages','uid,pid,title,subtitle,abstract,media');
    if ( $this->extConf['ownMarker_1'] ) $select .= ',pages.'.trim($this->extConf['ownMarker_1']);
    if ( $this->extConf['ownMarker_2'] ) $select .= ',pages.'.trim($this->extConf['ownMarker_2']);
   	$where = 'pages.uid IN('.$this->conf['pages'].')';
   	$where .= $this->cObj->enableFields('pages');
  	$rows = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows($select, 'pages', $where, '', ' FIELD(uid, '. $this->conf['pages'] .')');
		$pageRecords = array();
    foreach( $rows as $key=>$row ) {
      $pageRecords[$key] = $row;
      $pageRecords[$key]['image'] = t3lib_div::trimExplode(',', $pageRecords[$key]['media']); 
      $pageRecords[$key]['image'] = $pageRecords[$key]['image']['0'];
      unset($pageRecords[$key]['media']);
      if ( $GLOBALS['TSFE']->sys_language_content ) {
        $origImg = $pageRecords[$key]['image'];
        $OLmode = $GLOBALS['TSFE']->sys_language_mode == 'strict' ? 'hideNonTranslated' : '';
    		$pageRecords[$key] = $GLOBALS['TSFE']->sys_page->getPageOverlay($pageRecords[$key], $GLOBALS['TSFE']->sys_language_content, $OLmode);
        $pageRecords[$key]['image'] = $pageRecords[$key]['image'] ? $pageRecords[$key]['image'] : $origImg;
        if ( $GLOBALS['TSFE']->sys_language_mode == 'strict' && !$pageRecords[$key]['_PAGES_OVERLAY'] ) $unset = TRUE;
      }
      if( $this->DAM ) {
        $pageRecords[$key]['image'] = '';
        $pageRecords[$key] = $this->getDamData($pageRecords[$key], 'pages', 'tx_dampages_files');
      }
      if ( $unset ) unset($pageRecords[$key]);
		}

    return $pageRecords; 
  }


  protected function getNews( $sliderRecords=array() ) {
    // if no template is loaded - use the default template
    $this->conf['templateFile'] = $this->conf['templateFile'] ? $this->conf['templateFile'] : $this->extPath.'slidernews_template.html';
    $templateFile = $this->cObj->fileResource($this->conf['templateFile']);
    $templateFile = $this->cObj->getSubpart($templateFile,'###SLIDERSTYLE_'.$this->conf['sliderStyle'].'###');   
     // get global marker
    $marks = $this->getGlobalMarker();  
    // get the default images
    $defaultImages = $this->getDefaultImages();
    // general link configuration
    $linkConf = array();
    $linkConf['useCacheHash'] = 1;
    $linkConf['ATagParams'] = 'class="readmore"';
    $emailLinkConf = array();
    $emailLinkConf['ATagParams'] = 'class="author-email"';
    // singlePid
    $parameter = $this->conf['ttnewsSinglePid'] ? $this->conf['ttnewsSinglePid'] :  $GLOBALS['TSFE']->tmpl->setup['plugin.']['tt_news.']['singlePid'];

    $marksItem = array();
    $imageConf = array();
    $thumbConf = array();
    $record = array();
    $sliderRecords = array_merge($sliderRecords);
    foreach ( $sliderRecords as $key=>$record ) {
      // ff option catSinglePid
      if($this->conf['catSinglePid']) {
        $catCount = count($record['catDetail']);
        if ( $catCount == 1 ) {
          $single_pid = array_values($record['catDetail']);
          $single_pid = $catDetail['0']['single_pid'];
          $parameter = $single_pid ? $single_pid : $parameter;
        } elseif ( $catCount > 1 ) {
          foreach ($record['catDetail'] as $catDetail) {
            if ( $catDetail['mmsorting'] == 1 ) {
              $parameter = $catDetail['single_pid'] ? $catDetail['single_pid'] : $parameter;
            }
          }
        }
      } 
      // link configuration
      $linkConf['parameter'] = $parameter;
      $linkConf['additionalParams'] = $record['addParam'];
      $linkConf['title'] = $record['title'];
      // if tt_news type is an internal- or external link
      if ( $record['type'] == 1 || $record['type'] == 2 ) {
        $pkey = $record['type'] == 1 ? 'page' : 'ext_url';
        $linkConf['parameter'] = $record[$pkey];
        unset($linkConf['additionalParams']);
        unset($linkConf['useCacheHash']);
      }
      $emailLinkConf['parameter'] = $record['author_email'];
      $emailLinkConf['title'] = $this->pi_getLL('emailTo').' '.$record['author'];
      // text-fields conversion
      $record = $this->textConversion( $record );
      // image configuration
      $randbefore = $randbefore ? $randbefore : 0;
      $imageFileConf = list ( $record, $imageConf, $thumbConf, $randbefore ) = $this->imageConf( $record, $defaultImages, $key, $randbefore );
      $record = $imageFileConf[0]; 
      $imageConf = $imageFileConf[1];
      $thumbConf = $imageFileConf[2];
      $randbefore = $imageFileConf[3];
      // get the general record-marker
      $marksItem = $this->getRecordMarker( $record, $linkConf );
      // author-marker
      $marksItem['###AUTHOR###']  = $record['author'] ? '<span class="author">'.$record['author'].'</span>' : '';
      $marksItem['###AUTHOR_ICON###']  = $record['author'] ? '<span class="author_icon">'.$record['author'].'</span>' : '';
      $marksItem['###AUTHORLINK###']  = $record['author'] ? '<span class="author">'.$record['author'].'</span>' : '';
      $marksItem['###AUTHORLINK_ICON###']  = $record['author'] ? '<span class="author_icon">'.$record['author'].'</span>' : '';
      if ( $record['author_email'] ) {
        $marksItem['###AUTHORLINK###']  = $record['author'] ? '<span class="author">'.$this->cObj->typolink($record['author'], $emailLinkConf).'</span>' : '';
        $marksItem['###AUTHORLINK_ICON###']  = $record['author'] ? '<span class="author_icon">'.$this->cObj->typolink($record['author'], $emailLinkConf).'</span>' : '';
      }
      // image-marker
      $marksItem['###IMAGE###'] = $this->cObj->IMAGE($imageConf);
      if ( $this->conf['imageLink'] ) $marksItem['###IMAGE###'] = $this->cObj->typolink($marksItem['###IMAGE###'], $linkConf);
      $marksItem['###THUMBNAIL###'] = $this->cObj->IMAGE($thumbConf);
      // number-marker
      $marksItem['###NUMBER###']  = $this->conf['sliderStyle'] == 7 ? ($this->cObj->data['uid'].'-'.($key+1)) : ($key+1);

  		$templateFileItem = $this->cObj->getSubpart($templateFile,'###SLIDER###');		
  		$subpartContentArray['###SLIDER###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
  		$templateFileItem = $this->cObj->getSubpart($templateFile,'###NAVIGATION###');		
  		$subpartContentArray['###NAVIGATION###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
      // pagination-marker
      if ( $this->conf['pagination'] ) {
        $pagination .= '<li id="getSelectedValue'. $key .'" class="selector">'. ($key+1) .'</li>';	
      }
    }
    $marks['###PAGINATION###'] = $this->conf['pagination'] ? '<ul class="navigationControl lof-navigator" style="width:'.$this->sliderWidth.'px; overflow:hidden;">'. $pagination .'</ul>' : ''; 
    $content = $this->cObj->substituteMarkerArrayCached($templateFile, $marks, $subpartContentArray);    
 
    return $content;
  }

 
 	protected function getContent( $sliderRecords=array() ) {
    $recCount = count($sliderRecords);
    // if no template is loaded - use the default template
    $this->conf['templateFile'] = $this->conf['templateFile'] ? $this->conf['templateFile'] : $this->extPath.'slidercontent_template.html';
    $templateFile = $this->cObj->fileResource($this->conf['templateFile']);
    $templateFile = $this->cObj->getSubpart($templateFile,'###SLIDERSTYLE_'.$this->conf['sliderStyle'].'###');   
     // get global marker
    $marks = $this->getGlobalMarker();  
    // get the default images
    $defaultImages = $this->getDefaultImages();
    // general link configuration
    $linkConf = array();
    $linkConf['ATagParams'] = 'class="readmore"';

    $marksItem = array();
    $imageConf = array();
    $thumbConf = array();
    $record = array();
    foreach ( $sliderRecords as $key=>$record ) {
      $linkToDefaultSide = 'TRUE';
      // link configuration
      $linkConf['title'] = $record['header'];
      if ( $this->conf['defaultLink'] ) { 
        $linkToDefaultSide = 'FALSE';   
        $defaultLinks = t3lib_div::trimExplode(',', $this->conf['defaultLink']);
        $linkConf['parameter'] = $defaultLinks[$key];  
        if ( count($defaultLinks) == ($key+1) ) $linkToDefaultSide = 'TRUE';
      } else {
        if ( $record['header_link'] && $this->extConf['useHeaderLink'] ) {
          $linkConf['parameter'] = $record['header_link'];
        } else {
          $linkConf['parameter'] = $record['pid'];
          $linkConf['section'] = $record['uid'];
        }
      }
      // text-fields conversion
      $record = $this->textConversion( $record );
      // image configuration
      $randbefore = $randbefore ? $randbefore : 0;
      $imageFileConf = list ( $record, $imageConf, $thumbConf, $randbefore ) = $this->imageConf( $record, $defaultImages, $key, $randbefore );
      $record = $imageFileConf[0]; 
      $imageConf = $imageFileConf[1];
      $thumbConf = $imageFileConf[2];
      $randbefore = $imageFileConf[3]; 
      // get the general record-marker
      $marksItem = $this->getRecordMarker( $record, $linkConf );
      // subtitle-marker
      $marksItem['###SUBTITLE###'] = $record['subheader'] ? $record['subheader'] : '';
      // image-marker
      $marksItem['###IMAGE###'] = $this->cObj->IMAGE($imageConf);
      if ( $this->conf['imageLink'] ) $marksItem['###IMAGE###'] = $this->cObj->typolink($marksItem['###IMAGE###'], $linkConf);
      $marksItem['###THUMBNAIL###'] = $this->cObj->IMAGE($thumbConf);
      // number-marker
      $marksItem['###NUMBER###']  = $this->conf['sliderStyle'] == 7 ? $this->cObj->data['uid'].'-'.($key+1) : ($key+1);

  		$templateFileItem = $this->cObj->getSubpart($templateFile,'###SLIDER###');		
  		$subpartContentArray['###SLIDER###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
  		$templateFileItem = $this->cObj->getSubpart($templateFile,'###NAVIGATION###');		
  		$subpartContentArray['###NAVIGATION###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
      // pagination-marker
      if ( $this->conf['pagination'] ) {
        $pagination .= '<li id="getSelectedValue'. $key .'" class="selector">'. ($key+1) .'</li>';	
      }
    }
    $marks['###PAGINATION###'] = $this->conf['pagination'] ? '<ul class="navigationControl" style="width:'.$this->sliderWidth.'px; overflow:hidden;">'. $pagination .'</ul>' : ''; 
    $content = $this->cObj->substituteMarkerArrayCached($templateFile, $marks, $subpartContentArray);    
    if ( $linkToDefaultSide == 'TRUE' ) {  
      return $content;
    } else {
      if ($key == 0) $key = -1; 
      return '<p style="color:red;">ERROR - '.$this->extKey.': '.$this->pi_getLL('linkCount').' ('.($key+1).' / '.count($defaultLinks).')<p>';
    }
  }


 	protected function getMenu( $sliderRecords=array() ) {
    // if no template is loaded - use the default template
    $this->conf['templateFile'] = $this->conf['templateFile'] ? $this->conf['templateFile'] : $this->extPath.'slidermenu_template.html';
    $templateFile = $this->cObj->fileResource($this->conf['templateFile']);
    $templateFile = $this->cObj->getSubpart($templateFile,'###SLIDERSTYLE_'.$this->conf['sliderStyle'].'###');   
    // get global marker
    $marks = $this->getGlobalMarker();  
    // get the default images
    $defaultImages = $this->getDefaultImages();
    // general link configuration
    $linkConf = array();
    $linkConf['ATagParams'] = 'class="readmore"';

    $marksItem = array();
    $imageConf = array();
    $thumbConf = array();
    $record = array();
    foreach ( $sliderRecords as $key=>$record ) {
      // link configuration
      $linkConf['title'] = $record['title'];
      $linkConf['parameter'] = $record['uid'];
      // text-fields conversion
      $record = $this->textConversion( $record );
      // image configuration
      $randbefore = $randbefore ? $randbefore : 0;
      $imageFileConf = list ( $record, $imageConf, $thumbConf, $randbefore ) = $this->imageConf( $record, $defaultImages, $key, $randbefore );
      $record = $imageFileConf[0]; 
      $imageConf = $imageFileConf[1];
      $thumbConf = $imageFileConf[2];
      $randbefore = $imageFileConf[3]; 
      // get the general record-marker
      $marksItem = $this->getRecordMarker( $record, $linkConf );
      // subtitle-marker
      $marksItem['###SUBTITLE###'] = $record['subheader'] ? $record['subheader'] : '';
      // image-marker
      $marksItem['###IMAGE###'] = $this->cObj->IMAGE($imageConf);
      if ( $this->conf['imageLink'] ) $marksItem['###IMAGE###'] = $this->cObj->typolink($marksItem['###IMAGE###'], $linkConf);
      $marksItem['###THUMBNAIL###'] = $this->cObj->IMAGE($thumbConf);
      // number-marker
      $marksItem['###NUMBER###']  = $this->conf['sliderStyle'] == 7 ? $this->cObj->data['uid'].'-'.($key+1) : ($key+1);

  		$templateFileItem = $this->cObj->getSubpart($templateFile,'###SLIDER###');		
  		$subpartContentArray['###SLIDER###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
  		$templateFileItem = $this->cObj->getSubpart($templateFile,'###NAVIGATION###');		
  		$subpartContentArray['###NAVIGATION###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
      // pagination-marker
      if ( $this->conf['pagination'] ) {
        $pagination .= '<li id="getSelectedValue'. $key .'" class="selector">'. ($key+1) .'</li>';	
      }
    }   
    $marks['###PAGINATION###'] = $this->conf['pagination'] ? '<ul class="navigationControl" style="width:'.$this->sliderWidth.'px; overflow:hidden;">'. $pagination .'</ul>' : ''; 
    $content = $this->cObj->substituteMarkerArrayCached($templateFile, $marks, $subpartContentArray);    
 
    return $content;
  }


 	protected function getGlobalMarker() {
    // navigator -setting
    $this->conf['navigatorHeight'] = $this->conf['navigatorHeight'] ? $this->conf['navigatorHeight'] : 100;
    $this->conf['navigatorWidth'] = $this->conf['navigatorWidth'] ? $this->conf['navigatorWidth'] : 310;
    $this->conf['navigatorHeight'] = t3lib_div::intInRange($this->conf['navigatorHeight'], 40, 200);
    $this->conf['navigatorWidth'] = t3lib_div::intInRange($this->conf['navigatorWidth'], 40, 400);
    if ( $this->conf['sliderStyle'] == 4 ) {
      $this->conf['navigatorHeight'] = 15;
      $this->conf['navigatorWidth'] = 25;
    }
    // slider -setting
    $this->sliderWidth = $this->conf['sliderWidth'] ? $this->conf['sliderWidth'] : 700;
    $this->sliderHeight = $this->conf['sliderHeight'] ? $this->conf['sliderHeight'] : 300;
    if ( $this->conf['sliderStyle'] == 2 || $this->conf['sliderStyle'] == 3 || $this->conf['sliderStyle'] == 6 ) { 
      $this->sliderHeight = $this->conf['maxItemDisplay'] * $this->conf['navigatorHeight'];
    }
    // image -setting
    $this->imageWidth = $this->sliderWidth;
    $this->imageHeight = $this->sliderHeight;
    if ( $this->conf['sliderStyle'] == 2 && !$this->conf['variant'] ) $this->imageWidth = $this->sliderWidth - $this->conf['navigatorWidth'] + 15;
    if ( $this->conf['sliderStyle'] == 3 && !$this->conf['variant'] ) $this->imageWidth = $this->sliderWidth - $this->conf['navigatorWidth'] + 15;
    if ( $this->variant ) $this->imageWidth = $this->sliderWidth;
    if ( $this->conf['sliderStyle'] == 6 ) {
      $this->imageWidth = $this->sliderWidth - $this->conf['navigatorWidth'] - 30;
      $this->imageHeight = $this->conf['imageSixHeight'] ? $this->conf['imageSixHeight'] : 190;
    }
    // textarea -setting
    if ( $this->conf['textareaWidth'] ) {
      $this->conf['textareaWidth'] = t3lib_div::intval_positive($this->conf['textareaWidth']);
    } else {
      $this->conf['textareaWidth'] = 350;
      // 20 = 2 x 10px padding in css
      if ( $this->conf['sliderStyle'] == 5 ) $this->conf['textareaWidth'] = $this->sliderWidth - 20;
      if ( $this->conf['sliderStyle'] == 7 ) $this->conf['textareaWidth'] = $this->sliderWidth;
      if ( $this->variant ) $this->conf['textareaWidth'] = 200;
    }
    // thumbnail -setting
    $this->conf['thumbnailSize'] = $this->conf['thumbnailSize'] ? $this->conf['thumbnailSize'] : 60;
    $this->conf['thumbnailWidth'] = t3lib_div::intInRange($this->conf['thumbnailSize'], 20, $this->conf['navigatorHeight'] - 14);
    $this->conf['thumbnailHeight'] = $this->conf['thumbnailWidth'];
    if ( $this->conf['sliderStyle'] == 1 ) {
      $this->conf['proportion'] = $this->conf['proportion'] ? $this->conf['proportion'] : 10;
      $this->conf['thumbnailWidth']  = t3lib_div::intval_positive($this->imageWidth / $this->conf['proportion']);
      $this->conf['thumbnailHeight']  = t3lib_div::intval_positive($this->imageHeight / $this->conf['proportion']);
      $this->conf['navigatorWidth'] = $this->conf['thumbnailWidth'] + 10;
      $this->conf['navigatorHeight'] = $this->conf['verticalNav'] ? $this->conf['thumbnailHeight'] + 9 : $this->conf['thumbnailHeight'] + 6;
    }
    // textarea offset -setting
    if ( $this->conf['textareaOffsetBottom'] ) {
      $this->conf['textareaOffsetBottom'] = $this->conf['textareaOffsetBottom'];
    } else {
      $this->conf['textareaOffsetBottom'] = 50;
      if ($this->conf['sliderStyle'] == 5 || $this->conf['sliderStyle'] == 7) $this->conf['textareaOffsetBottom'] = 0;
    }
    if ($this->conf['textareaOffsetLeft']) {
      $this->conf['textareaOffsetLeft'] = $this->conf['textareaOffsetLeft'];
    } else {
      $this->conf['textareaOffsetLeft'] = 0;
      if ($this->conf['sliderStyle'] == 3) $this->conf['textareaOffsetLeft'] = 20;
    }
    if ($this->conf['textareaOffsetTop']) {
      $this->conf['textareaOffsetTop'] = $this->conf['textareaOffsetTop'];
    } else {
      $this->conf['textareaOffsetTop'] = 150;
      if ($this->variant) $this->conf['textareaOffsetTop'] = 0;
      $this->conf['marginTop'] = t3lib_div::intval_positive(($this->conf['navigatorHeight'] - $this->conf['thumbnailHeight']) / 2 - 3);
    }
    // marker
    $marks = array();
    $marks['###CEID###'] = t3lib_div::intval_positive($this->cObj->data['uid']);
    $marks['###SLIDERWIDTH###'] = $this->sliderWidth;
    $marks['###SLIDERHEIGHT###'] = $this->sliderHeight;
    $marks['###IMAGEHEIGHT###'] = $this->imageHeight;
    $marks['###IMAGEWIDTH###'] = $this->conf['sliderStyle'] == 6 ? $this->imageWidth +30 : $this->imageWidth;    
    if( $this->extConf['manualImageWidth'] ) $marks['###IMAGEWIDTH###'] = t3lib_div::intval_positive($this->extConf['manualImageWidth']);
    if( $this->extConf['manualImageHeight'] ) $marks['###IMAGEHEIGHT###'] = t3lib_div::intval_positive($this->extConf['manualImageHeight']);
    $marks['###IMAGEMARGIN###'] = 0;
    if ( $this->conf['sliderStyle'] == 3 ) {
      $marks['###IMAGEMARGIN###'] = $this->conf['variant'] ? 0 : $this->conf['navigatorWidth'] - 15;
    }
    $marks['###CSS3###'] = $this->conf['css3'] ? 'lof-css3' : '';
    $marks['###ACTNAVCOLOR###'] = $this->conf['activeNavBg'];
    $marks['###ARROW-STYLE###'] = '';
    $marks['###NAVIGATOR-BG###'] = '';
    $marks['###NAV-POSITION###'] = '';
    if( $this->conf['sliderStyle'] == 1 ) {
      $marks['###ARROW-STYLE###'] = $this->conf['verticalNav'] ? 'height:22px; width:'.($this->conf['thumbnailWidth'] + 10).'px;' : 'height:'.($this->conf['thumbnailHeight'] + 6).'px; width:22px;';
      if ($this->conf['noArrows']) $marks['###ARROW-STYLE###'] = '';
      $marks['###NAVIGATOR-BG###'] = 'lof-navigator-wapper_'.$this->conf['textareaBg'];
      $marks['###NAV-POSITION###'] = $this->conf['verticalNav'] ? 'lof-vertical' : 'lof-horizontal';
    }

    return $marks;
  }


 	protected function getDefaultImages() {
 	  $defaultImages = array();
    if ( $this->DAM ) {
      if ( $this->conf['defaultImageDAM'] ) {
        $fields = tx_dam_db::getMetaInfoFieldList();
        $fields .= ',tx_dam.caption,tx_dam.description,tx_dam.abstract,tx_dam.creator,tx_dam.publisher,tx_dam.copyright';
      	$defaultDamFiles = tx_dam_db::getReferencedFiles('tt_content', $this->cObj->data['uid'], 'tx_t3sjslidernews_images','',$fields);
        $defaultImages['files'] = array_merge($defaultDamFiles['files']);    
        $defaultImages['rows'] = array_merge($defaultDamFiles['rows']);
      } else {
        $defaultImages['files'] = '';
      }
    } else {
      $defaultImages['files'] = $this->conf['defaultImage'] ? t3lib_div::trimExplode(',', $this->conf['defaultImage']) : '';
    }  
       
    return $defaultImages; 
  }


 	protected function textConversion( $record=array() ) {      
    if ( $this->conf['contentStyle'] == 'tt_content' ) {
      $record['header'] = trim($record['header']);
      $record['header'] = $record['header'] ? htmlspecialchars($record['header']) : '';
      $record['subheader'] = trim($record['subheader']);
      $record['subheader'] = $record['subheader'] ? htmlspecialchars($record['subheader']) : '';
    } else {
      $record['title'] = trim($record['title']);
      $record['title'] = $record['title'] ? htmlspecialchars($record['title']) : '';
    }
    if ( $this->conf['contentStyle'] == 'tt_news' ) {
      $record['short'] = trim($record['short']);
      $record['short'] = $record['short'] ? t3lib_div::formatForTextarea($record['short']): '';
      $record['author_email'] = trim($record['author_email']);
      $record['author_email'] = t3lib_div::validEmail($record['author_email']) ? $record['author_email'] : '';       
      $record['author'] = trim($record['author']);
    }
    if ( $this->conf['contentStyle'] == 'pages' ) {
      $record['subtitle'] = trim($record['subtitle']);
      $record['subtitle'] = $record['subtitle'] ? htmlspecialchars($record['subtitle']) : '';
      $record['abstract'] = trim($record['abstract']);
      $record['abstract'] = $record['abstract'] ? t3lib_div::formatForTextarea($record['abstract']) : '';       
    } else {
      if ( $this->extConf['rteRendering'] ) {
        require_once(PATH_t3lib.'class.t3lib_parsehtml_proc.php');
        $bodytext_parsehtml_proc = t3lib_div::makeInstance('t3lib_parsehtml_proc');
  	    $record['bodytext'] = $bodytext_parsehtml_proc->TS_links_rte($record['bodytext']);
      } else {
  		  $record['bodytext'] = $this->pi_RTEcssText($record['bodytext']);    
      } 
    }

    return $record;
  }


 	protected function imageConf( $record=array(), $defaultImages=array(), $key, $randbefore ) {
    $dir = $this->conf['contentStyle'] == 'pages' ? 'media' : 'pics';
    $uploadDir = $this->DAM ? '' : 'uploads/'.$dir.'/';
    // ... only default images - no images from the tt_news-records
    if ( $this->conf['requireImage'] == 2 ) $record['image'] = '';
    // image configuration - file
    $imageConf['file'] = $record['image'] ? $uploadDir . $record['image'] : '';
    // add a default image to records without an image
    if ( !$record['image'] ) {
      if ( $defaultImages['files'] ) {
        $uploadDir = $this->DAM ? '' : 'uploads/tx_t3sjslidernews/';
        $imgCount = count($defaultImages['files']);
        if ( $imgCount == 1 ) {
          $record['image'] = $defaultImages['files'][0];
          $imageConf['file'] = $uploadDir . $defaultImages['files'][0];
          if ( $this->DAM ) $record = $this->getDefaultImagesDamData($record,$defaultImages,0);
debugster($imageConf['file']);
        } else {
          if ( $this->conf['imageOrder']) {
            $imageConf['file'] = $uploadDir . $defaultImages['files'][$key];
            if(!$defaultImages['files'][$key]) $imageConf['file'] = $this->extPath.'res/icons/typo3_logo.jpg';
            if ( $this->DAM ) $record = $this->getDefaultImagesDamData($record,$defaultImages,$key);
          } else {
            $random = mt_rand(1, $imgCount);
            if ( $random == $randbefore ) $random = $random == 1 ? $random + 1 : $random - 1;
            $randbefore = $random;
            $rKey = $random - 1;
            $record['image'] = $defaultImages['files'][$rKey];
            $imageConf['file'] = $uploadDir . $defaultImages['files'][$rKey];
            if ( $this->DAM ) $record = $this->getDefaultImagesDamData($record,$defaultImages,$rKey);
          }
        }
      } else {
        $imageConf['file'] = $this->extPath.'res/icons/typo3_logo.jpg';
      }
    }
    $thumbConf['file'] = $imageConf['file'];
    // image configuration - size & params
    if ( $this->extConf['manualImageWidth'] ) {
      $imageConf['file.']['width'] = t3lib_div::intval_positive($this->extConf['manualImageWidth']).'c';
    } else {
      $imageConf['file.']['width'] = $this->variant ? $this->sliderWidth.'c' : $this->imageWidth.'c'; 
    }
    $imageConf['file.']['height'] = $this->extConf['manualImageHeight'] ? t3lib_div::intval_positive($this->extConf['manualImageHeight']).'c' : $this->imageHeight.'c';
    // 7 = nivo-slider
    $imageConf['stdWrap.']['addParams.']['title'] = $this->conf['sliderStyle'] == 7 ? '#caption-'.$this->cObj->data['uid'].'-'.($key+1) : trim($record['imagetitletext']);
    $imageConf['stdWrap.']['addParams.']['alt'] = $record['imagealttext'];

    $thumbConf['file.']['height'] = $this->conf['thumbnailHeight'].'c';
    $thumbConf['file.']['width'] = $this->conf['thumbnailWidth'].'c';
    $thumbConf['stdWrap.']['addParams.']['style'] = $this->variant ? 'margin:'.$this->conf['marginTop'].'px 17px 0 17px' : 'margin:'.$this->conf['marginTop'].'px '.$this->conf['marginTop'].'px 0 0';

    return array($record, $imageConf, $thumbConf, $randbefore);
  }


 	protected function getDefaultImagesDamData( $record=array(), $defaultImages=array(), $rKey ) {
    $record['dam_title'] = trim($defaultImages['rows'][$rKey]['title']);
    $record['dam_caption'] = trim($defaultImages['rows'][$rKey]['caption']);
    $record['dam_description'] = trim($defaultImages['rows'][$rKey]['description']);
    $record['dam_abstract'] = trim($defaultImages['rows'][$rKey]['abstract']);
    $record['dam_creator'] = trim($defaultImages['rows'][$rKey]['creator']);
    $record['dam_publisher'] = trim($defaultImages['rows'][$rKey]['publisher']);
    $record['dam_copyright'] = trim($defaultImages['rows'][$rKey]['copyright']); 

    return $record;
  }


 	protected function getRecordMarker( $record=array(), $linkConf=array() ) {
    // title-marker
    $marksItem['###TITLE###'] = $this->conf['contentStyle'] == 'tt_content' ? $record['header'] : $record['title'];
    $marksItem['###TITLELINK###']  = $this->conf['contentStyle'] == 'tt_content' ? $this->cObj->typolink($record['header'], $linkConf) : $this->cObj->typolink($record['title'], $linkConf);
    // text-marker
    $this->conf['fixedLgd'] = $this->conf['fixedLgd'] ? $this->conf['fixedLgd'] : 120;
    $fixedLgdpParameter = $this->conf['fixedLgd'] . '|...|true';
    if ( $record['bodytext'] ) {
    	$count = strlen($record['bodytext']);        
    	if ( $count >= $this->conf['fixedLgd'] ) {
        $record['bodytext'] = $this->extConf['crop'] ? $this->cObj->cropHTML($record['bodytext'],$fixedLgdpParameter) : $this->cObj->crop(strip_tags($record['bodytext']),$fixedLgdpParameter);
        $marksItem['###READMORE###']  = $this->cObj->typolink($this->pi_getLL('readmore'), $linkConf);
    	} else {
       $marksItem['###READMORE###']  = '';
    	}
	    $marksItem['###TEXT###'] = $record['bodytext'];       
    } elseif ( $record['short'] ) {   
	    $short = t3lib_div::fixed_lgd_cs($record['short'], $this->conf['fixedLgd']);
	    $count = strlen($short) - 3;
      if ( $count >= $this->conf['fixedLgd'] ) {
        $record['short'] = $this->cObj->crop(strip_tags($record['short']),$fixedLgdpParameter);
        $marksItem['###READMORE###']  = $this->cObj->typolink($this->pi_getLL('readmore'), $linkConf);
      } else {
        $marksItem['###READMORE###']  = '';
      }
      $marksItem['###TEXT###'] = $record['short'];       
    }  elseif ( $record['abstract'] ) {
    	$count = strlen($record['bodytext']);        
    	if ( $count >= $this->conf['fixedLgd'] ) {
				$record['abstract'] = $this->cObj->crop(strip_tags($record['abstract']),$fixedLgdpParameter);       
        $marksItem['###READMORE###']  = $this->cObj->typolink($this->pi_getLL('readmore'), $linkConf);
    	} else {
       $marksItem['###READMORE###']  = '';
    	}
	    $marksItem['###TEXT###'] = $record['abstract'];       
    } else {
    	$marksItem['###TEXT###'] = ''; 
      $marksItem['###READMORE###']  = '';
    }
    // date-marker
    $dateField = 'datetime';
    if ( $this->conf['contentStyle'] == 'tt_content' ) $dateField = 'date';
    if ( $this->conf['contentStyle'] == 'pages' )      $dateField = 'lastUpdated';
    if ( $GLOBALS['TSFE']->tmpl->setup['config.']['renderCharset'] == 'utf-8' ) {
      $marksItem['###DATE###'] = $this->conf['disableUtf8Encode'] ? '<span class="date">'.strftime($this->conf['dateFormat'],$record[$dateField]).'</span>' : '<span class="date">'. utf8_encode(strftime($this->conf['dateFormat'],$record[$dateField])).'</span>'; 
    } else {
      $marksItem['###DATE###'] = '<span class="date">'.strftime($this->conf['dateFormat'],$record[$dateField]).'</span>';
    }
    $marksItem['###DATE_ICON###'] = '<span class="date_icon">'.strftime($this->conf['dateFormat'],$record[$dateField]).'</span>';
    // category-marker
    if ( $this->conf['contentStyle'] == 'tt_news' ) {
      $record['catTitleList'] = t3lib_div::rm_endcomma(trim($record['catTitleList']));
      $marksItem['###CATEGORY###'] = '<span class="category">'.$record['catTitleList'].'</span>';
      $marksItem['###CATEGORY_ICON###']  = '<span class="category_icon">'.$record['catTitleList'].'</span>';
    }
    // other marker
    $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.$this->conf['textareaWidth'].'px; top:'.$this->conf['textareaOffsetTop'].'px; left:'.$this->conf['textareaOffsetLeft'].'px;';
    if($this->conf['sliderStyle'] == 1 || $this->conf['sliderStyle'] == 4 || $this->conf['sliderStyle'] == 5) {
      $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.$this->conf['textareaWidth'].'px; bottom:'.$this->conf['textareaOffsetBottom'].'px; left:'.$this->conf['textareaOffsetLeft'].'px;';
    }
    if( $this->conf['sliderStyle'] == 6 ) $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.$this->imageWidth.'px;';
    if( $this->conf['sliderStyle'] == 2 && $this->conf['variant'] ) $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.$this->conf['textareaWidth'].'px; top:0px; left:0px;';
    if( $this->conf['sliderStyle'] == 3 && $this->conf['variant'] ) $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.$this->conf['textareaWidth'].'px; top:0px; right:0px;';
    $marksItem['###DESCRIPTION-BG###'] = 'lof-description_'.$this->conf['textareaBg'];
    $paddingLeft = t3lib_div::intInRange($this->conf['marginTop'], '10', '100');
    $marksItem['###NAVSELECTOR-STYLE###'] = 'padding-left: '.$paddingLeft.'px;';
    if( $this->conf['sliderStyle'] == 2 && $this->conf['variant'] ) $marksItem['###NAVSELECTOR-STYLE###'] = 'padding-left:0';
    $marksItem['###HEADER-STYLE###'] = $this->conf['fontSize'] ? 'font-size:'.intval($this->conf['fontSize']).$this->conf['fontUnit'].';' : 'font-size:120%;';
    // dam-marker
    if ( $this->DAM ) {
    	$marksItem['###DAM_TITLE###'] =  $record['dam_title']; 
    	$marksItem['###DAM_DESCRIPTION###'] =  $record['dam_description'];
    	$marksItem['###DAM_CAPTION###'] =  $record['dam_caption'];
    	$marksItem['###DAM_ABSTRACT###'] =  $record['dam_abstract'];
    	$marksItem['###DAM_CREATOR###'] =  $record['dam_creator'];
    	$marksItem['###DAM_PUBLISHER###'] =  $record['dam_publisher'];
    	$marksItem['###DAM_COPYRIGHT###'] =  $record['dam_copyright'];
    }
    // own-marker
    if ( $this->extConf['ownMarker_1'] || $this->extConf['ownMarker_2'] ) {
    $marksItem['###OWN_MARKER_ONE###'] = $record[$this->extConf['ownMarker_1']] ? $record[$this->extConf['ownMarker_1']] : '';
    $marksItem['###OWN_MARKER_TWO###'] = $record[$this->extConf['ownMarker_2']] ? $record[$this->extConf['ownMarker_2']] : '';
    }

    return $marksItem;
  }


  protected function getDamData( $record=array(), $table, $ref) {
    $fields = tx_dam_db::getMetaInfoFieldList();
    $fields .= ',tx_dam.caption,tx_dam.description,tx_dam.abstract,tx_dam.creator,tx_dam.publisher,tx_dam.copyright';
  	$damImgList = tx_dam_db::getReferencedFiles($table, $record['uid'], $ref,'',$fields);
  	if( count($damImgList['files']) ) {
      $record['image'] = array_shift($damImgList['files']);     
    }
    $damRows = array_shift($damImgList['rows']);
    $record['dam_title'] = $damRows['title'] ? trim($damRows['title']) : '';
    $record['dam_caption'] = $damRows['caption'] ? trim($damRows['caption']) : '';
    $record['dam_description'] = $damRows['description'] ? trim($damRows['description']) : '';
    $record['dam_abstract'] = $damRows['abstract'] ? trim($damRows['abstract']) : '';
    $record['dam_creator'] = $damRows['creator'] ? trim($damRows['creator']) : '';
    $record['dam_publisher'] = $damRows['publisher'] ? trim($damRows['publisher']) : '';
    $record['dam_copyright'] = $damRows['copyright'] ? trim($damRows['copyright']) : '';       

    return $record;
  }


  protected function getRgnewsce( $record=array() ) {
   	$where = 'uid IN('.$record['tx_rgnewsce_ce'].') AND CType = \'textpic\' AND deleted = 0 AND hidden = 0';
  	$ce_rows = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('uid, header, bodytext, image', 'tt_content', $where, '', ' FIELD(uid, '.$record['tx_rgnewsce_ce'] .')');
  	if ( $record['type'] == 0 || $record['type'] == 1 || $record['type'] == 2 ) {
  		foreach( $ce_rows as $ce_row ) {
        if( $this->extConf['rgnewsceText'] ) {
          $record['short'] = $ce_row['bodytext'] ? $ce_row['bodytext'] : $record['short'];
          $record['title'] = $ce_row['header'] ? $ce_row['header'] : $record['title'];
        }
        unset($ce_row['bodytext']);
        unset($ce_row['header']);
        if( t3lib_extMgm::isLoaded('dam_ttcontent') ) {
          $damData = $this->getDamData($ce_row, 'tt_content', 'tx_damttcontent_files' );
          unset($ce_row['uid']);
          unset($damData['uid']);
          $record = $damData ? t3lib_div::array_merge_recursive_overrule($record, $damData) : $record;
 				} else {
					if( strlen($ce_row['image']) ) {
            $record['image'] = t3lib_div::trimExplode(',' , $ce_row['image']);
            $record['image'] = $record['image'][0];
					}
				}
			}  
		}

    return $record;
  }


  protected function addJquery($pagerender,$queryNoConflict) {
    // checks if t3jquery is loaded
    if ( t3lib_extMgm::isLoaded('t3jquery') ) {
      require_once(t3lib_extMgm::extPath('t3jquery').'class.tx_t3jquery.php');
    }
    // if t3jquery is loaded and the custom Library had been created
    if ( T3JQUERY === true ) {
      tx_t3jquery::addJqJS();
    }
    if ( $this->extConf['includeJquery'] ) {
      $version = $this->extConf['jVersion'] ? $this->extConf['jVersion'] : 1;
      if ( $this->extConf['additionalHeaderData'] ) {
        $addJquery = '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/'.$version.'/jquery.min.js"></script>';
        $GLOBALS['TSFE']->additionalHeaderData[$this->extKey.'.js1'] = $$addJquery; 
      } else {
        if ( $this->extConf['moveJsFromFooterToHeader'] ){
          $pagerender->addJsLibrary(' jQuery JavaScript Library ','https://ajax.googleapis.com/ajax/libs/jquery/'.$version.'/jquery.min.js', 'text/javascript', TRUE, FALSE, '');
        } else {
          $pagerender->addJsFooterLibrary(' jQuery JavaScript Library ','https://ajax.googleapis.com/ajax/libs/jquery/'.$version.'/jquery.min.js', 'text/javascript', TRUE, FALSE, '');
        }          
      }
    }
  }


  protected function addHeaderParts( $pagerender, $queryNoConflict ) {
    // jQuery easing
    if( $this->extConf['includeJqueryEasing'] ) {
      if ( $this->extConf['additionalHeaderData'] ) {
        $GLOBALS['TSFE']->additionalHeaderData[$this->extKey.'.js2'] = '<script type="text/javascript" src="'.$this->extPath.'res/js/jquery.easing.js"></script>'; 
      } else {
        if ( $this->extConf['moveJsFromFooterToHeader'] ) {
          $pagerender->addJsFile($this->extPath.'res/js/jquery.easing.js', 'text/javascript', TRUE, FALSE, '');
        } else {
          $pagerender->addJsFooterFile($this->extPath.'res/js/jquery.easing.js', 'text/javascript', TRUE, FALSE, '');
        }
      }
    }
    // jslidernews
    $script = $this->variant ? 'jslidernewsHoverInt.js' : 'jslidernews.js';
    if ( $this->extConf['additionalHeaderData'] ) {
      $GLOBALS['TSFE']->additionalHeaderData[$this->extKey.'.js3'] = '<script type="text/javascript" src="'.$this->extPath.'res/js/'.$script.'"></script>'; 
    } else {
      if ( $this->extConf['moveJsFromFooterToHeader'] ) {
        $pagerender->addJsFile($this->extPath.'res/js/'.$script, 'text/javascript', TRUE, FALSE, '');
      } else {
        $pagerender->addJsFooterFile($this->extPath.'res/js/'.$script, 'text/javascript', TRUE, FALSE, '');
      }          
    }
    // inlineJS setting
    // 2 x 15 image-margin
    if ($this->conf['sliderStyle'] == 6) $this->imageWidth = $this->imageWidth + 30;   
    $ceid = $this->cObj->data['uid'];  
    $direction = $this->conf['direction'] ? 'opacity' : ''; 
    $interval = $this->conf['interval'] ? $this->conf['interval'] : 4000;
    $auto = $this->conf['auto'] ? 'true' : 'false';
    $navPosition = '';
    if ($this->conf['sliderStyle'] == 1 || $this->conf['sliderStyle'] == 4) $navPosition =  $this->conf['verticalNav'] ? 'vertical' : 'horizontal';
    $duration = $this->conf['duration'] ? t3lib_div::intval_positive($this->conf['duration']) : 1200;
    $fire = 'jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {'; 
    if ($this->conf['sliderStyle'] == 4) {
      $fire = '$obj = jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {'; 
    }
    if ($this->conf['sliderStyle'] == 1 || $this->conf['sliderStyle'] == 5) {
      $fire = '          var buttons = { previous:jQuery(\'#lofslidecontent'.$ceid.' .lof-previous\') ,
next:jQuery(\'#lofslidecontent'.$ceid.' .lof-next\') };
$obj = jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {
buttons         : buttons,';  
    }
    // variant - slideOut navigation
    if ($this->variant) {
      $short1 = t3lib_div::intval_positive($this->conf['navigatorWidth'] - $this->conf['thumbnailHeight'] - 40);
      $short2 = t3lib_div::intval_positive($this->conf['navigatorWidth'] - 17);
      $short = $this->conf['variant'] == 2 ? $short2 : $short1;
      $tall = $this->conf['variant'] == 2 ? '-'.$short2 + $this->conf['thumbnailHeight'] + 17 : 0; 
      $leftRight = $this->conf['sliderStyle'] == 3 ? 'left' : 'right';
      $variantCode = 'jQuery(\'.lof-navigator-outer\').css(\''.$leftRight.'\', \'-'.$short.'px\');
jQuery(\'.lof-navigator-outer\').hoverIntent({
  over: makeTall,
  timeout: 500,
  out: makeShort
});';
      $variantCodeOut = 'function makeTall(){ jQuery(this).animate({\''.$leftRight.'\':'.$tall.'},200);}     
function makeShort(){ jQuery(this).animate({\''.$leftRight.'\':-'.$short.'},200);}';
    }
    // inlineJS
    $inlineJS = $queryNoConflict.'(document).ready( function(){          
'.$fire.'
      direction       : \''.$direction.'\',
      navigatorEvent  : \''.$this->conf['event'].'\',
      interval        : '.$interval.',      
      auto            : '.$auto.',
      maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
      navPosition     : \''.$navPosition.'\',
      navigatorHeight : '.$this->conf['navigatorHeight'].',
      navigatorWidth  : '.$this->conf['navigatorWidth'].',
      duration        : '.$duration.',
      easing          : \''.$this->conf['easing'].'\',
      mainWidth       : '.$this->imageWidth.'
      });  
'.$variantCode.'
});
'.$variantCodeOut;
    // CSS-File
    $cssFile = $this->conf['cssFile'] ? $this->conf['cssFile'] : $this->extPath.'res/css/style'.$this->conf['sliderStyle'].'.css';
    if ($this->variant) $cssFile = $this->conf['cssFile'] ? $this->conf['cssFile'] : $this->extPath.'res/css/style'.$this->conf['sliderStyle'].'v.css';
    // add CSS-File & inlineJS
    if ($this->extConf['additionalHeaderData']) {
      $GLOBALS['TSFE']->additionalHeaderData[$this->extKey.'.css'.$ceid] = '<link rel="stylesheet" type="text/css" href="'.$cssFile.'" />'; 
      $GLOBALS['TSFE']->additionalJavaScript[$this->extKey.'.jsCE-'.$ceid] = $inlineJS; 
    } else {
      $pagerender->addCssFile($cssFile, $rel = 'stylesheet', $media = 'all', $title = 'stylesheet',	$compress = TRUE,	$forceOnTop = FALSE, $allWrap = ''); 
      $name=' JavaScript for EXT '.$this->extKey.' CE-'.$ceid.' ';
      if ($this->extConf['moveInlineJsFromFooterToHeader']) {
        $pagerender->addJsInlineCode($name,$inlineJS);
      } else {
        $pagerender->addJsFooterInlineCode($name,$inlineJS);
      }
    }
  }



	protected function addNivoHeaderParts( $pagerender, $queryNoConflict ) {
    // Nivo Slider
    if ( $this->extConf['additionalHeaderData'] ) {
      $GLOBALS['TSFE']->additionalHeaderData[$this->extKey.'.js3'] = '<script type="text/javascript" src="'.$this->extPath.'res/js/jquery.nivo.slider.js"></script>'; 
    } else {
      if ( $this->extConf['moveJsFromFooterToHeader' ]) {
        $pagerender->addJsFile($this->extPath.'res/js/jquery.nivo.slider.js', 'text/javascript', TRUE, FALSE, '');
      } else {
        $pagerender->addJsFooterFile($this->extPath.'res/js/jquery.nivo.slider.js', 'text/javascript', TRUE, FALSE, '');
      }          
    }
    $ceid = $this->cObj->data['uid'];
    if($this->conf['captionOpacity'] != '0.8') $options .= 'captionOpacity:'.$this->conf['captionOpacity'].',';
    if($this->conf['effect'] != 'random')   $options .= 'effect:\''.$this->conf['effect'].'\',';
    if($this->conf['slices'])               $options .= 'slices:'.$this->conf['slices'].',';
    if($this->conf['animSpeed'])            $options .= 'animSpeed:'.$this->conf['animSpeed'].',';
    if($this->conf['pauseTime'])            $options .= 'pauseTime:'.$this->conf['pauseTime'].',';
    if($this->conf['manualAdvance'])        $options .= 'manualAdvance:true,';
    if(!$this->conf['pauseOnHover'])        $options .= 'pauseOnHover:false,';
    if(!$this->conf['directionNav'])        $options .= 'directionNav:false,';
    if(!$this->conf['directionNavHide'])    $options .= 'directionNavHide:false,';
    if(!$this->conf['controlNav'])          $options .= 'controlNav:false,';
    if(!$this->conf['keyboardNav'])         $options .= 'keyboardNav:false,';
    if($this->conf['boxCols'])              $options .= 'boxCols:\''.$this->conf['boxCols'].'\',';
    if($this->conf['boxRows'])              $options .= 'boxRows:\''.$this->conf['boxRows'].'\',';
    if($this->conf['textareaBg'] == 'white') {
        $options .= 'captionBackground:\''.$this->conf['textareaBg'].'\',';
        $options .= 'captionColor:\'black\',';
    }
    if($this->conf['textareaBg'] == 'nobg')    $options .= 'captionBackground:\'transparent\',';
    if($this->conf['textareaWidth'])           $options .= 'captionWidth:\''.$this->conf['textareaWidth'].'px\',';
    if($this->conf['textareaOffsetBottom'])    $options .= 'captionBottom:\''.$this->conf['textareaOffsetBottom'].'px\',';
    if($this->conf['textareaOffsetLeft'])      $options .= 'captionLeft:\''.$this->conf['textareaOffsetLeft'].'px\',';
    $options = t3lib_div::rm_endcomma($options);
    $name=' JavaScript for EXT '.$this->extKey.' ';
    if ($options) {
      $inlineJs = $queryNoConflict.'(window).load(function() {jQuery(\'#nivoslider'.$ceid.'\').nivoSlider({'.$options.'});});';
    } else {
      $inlineJs = $queryNoConflict.'(window).load(function() {jQuery(\'#nivoslider'.$ceid.'\').nivoSlider();});';
    }
    $cssFile = $this->conf['cssFile'] ? $this->conf['cssFile'] : $this->extPath.'res/css/nivo.css';
    if ($this->extConf['additionalHeaderData']) {
      $GLOBALS['TSFE']->additionalHeaderData[$this->extKey.'.css'.$ceid] = '<link rel="stylesheet" type="text/css" href="'.$cssFile.'" />'; 
      $GLOBALS['TSFE']->additionalJavaScript[$this->extKey.'.jsCE-'.$ceid] = $inlineJs; 
    } else {
      $pagerender->addCssFile($cssFile, $rel = 'stylesheet', $media = 'all', $title = 'stylesheet',	$compress = TRUE,	$forceOnTop = FALSE, $allWrap = ''); 
      $name=' JavaScript for EXT '.$this->extKey.' CE-'.$ceid.' ';
      if ($this->extConf['moveJsFromFooterToHeader']){
        $pagerender->addJsInlineCode($name,$inlineJs);
      }else{
        $pagerender->addJsFooterInlineCode($name,$inlineJs);
      };
    }
  }


}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3s_jslidernews/pi1/class.tx_t3sjslidernews_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3s_jslidernews/pi1/class.tx_t3sjslidernews_pi1.php']);
}

?>